# Architecture Diagrams

This directory contains Mermaid diagrams illustrating the platform's architecture and component relationships.

## Available Diagrams

1. **Package Architecture**
   - Shows all platform packages
   - Illustrates package dependencies
   - Highlights core, contracts, and infrastructure layers

2. **Request Lifecycle**
   - Details HTTP request flow
   - Shows middleware pipeline
   - Illustrates dependency injection points

3. **Service Container Flow**
   - Shows dependency injection process
   - Illustrates service provider lifecycle
   - Details service resolution

4. **Event System**
   - Shows event dispatching
   - Illustrates listener handling
   - Details queue integration

5. **Database Layer**
   - Shows model relationships
   - Illustrates query building
   - Details migration system

6. **Package Dependencies**
   - Complete dependency graph
   - Core package relationships
   - Infrastructure dependencies

## Usage

These diagrams are written in Mermaid markdown syntax and can be:
1. Viewed directly in GitHub
2. Rendered using Mermaid CLI
3. Integrated into documentation

## Updating

When making architectural changes:
1. Update relevant diagrams
2. Ensure accuracy
3. Keep consistent with implementation

See [architecture.md](architecture.md) for the actual diagrams.
